blob: 4a4287ad6f7f9fa751d63549e258555fb28123b2 [file] [log] [blame]
garciadeblasd8bc5c32018-05-09 17:37:56 +02001#!/bin/bash
garciadeblasd8bc5c32018-05-09 17:37:56 +02002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
garciadeblas0bc87522021-10-20 22:16:17 +020014#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015
16function usage(){
garciadeblas0bc87522021-10-20 22:16:17 +020017 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020018 echo -e "usage: $0 [OPTIONS]"
19 echo -e "Install OSM from binaries or source code (by default, from binaries)"
20 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000021 echo -e " -h / --help: print this help"
22 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblasd8bc5c32018-05-09 17:37:56 +020023 echo -e " -r <repo>: use specified repository name for osm packages"
24 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
25 echo -e " -u <repo base>: use specified repository url for osm packages"
26 echo -e " -k <repo key>: use specified repository public key url"
27 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
28 echo -e " -b master (main dev branch)"
29 echo -e " -b v2.0 (v2.0 branch)"
30 echo -e " -b tags/v1.1.0 (a specific tag)"
31 echo -e " ..."
garciadeblas0bc87522021-10-20 22:16:17 +020032 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
vijaynag8339ed22019-07-25 17:10:58 +053033 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
Mike Marchettib8420852018-09-13 13:45:06 -040034 echo -e " -H <VCA host> use specific juju host controller IP"
35 echo -e " -S <VCA secret> use VCA/juju secret key"
garciadeblasaa3ddf42019-04-04 19:04:32 +020036 echo -e " -P <VCA pubkey> use VCA/juju public key file"
Adam Israel5ddc97f2019-09-03 18:11:12 -040037 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
magnussonl1bbe9452020-02-25 13:43:17 +010038 echo -e " --pla: install the PLA module for placement support"
garciadeblas7b53d262022-11-04 23:18:48 +010039 echo -e " --ng-sa: install Airflow and Pushgateway to get VNF and NS status (experimental)"
beierlmcca93642021-05-03 16:29:14 -040040 echo -e " -m <MODULE>: install OSM but only rebuild or pull the specified docker images (NG-UI, NBI, LCM, RO, MON, POL, PLA, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, NONE)"
garciadeblasfa3eb332022-11-15 14:11:56 +010041 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (k8s_monitor, ng-sa)"
Antonio Marsico75a38c72020-12-21 17:29:42 +010042 echo -e " -O <openrc file path/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020043 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
Antonio Marsico75a38c72020-12-21 17:29:42 +010044 echo -e " -f <path to SSH public key>: Public SSH key to use to deploy OSM to OpenStack"
45 echo -e " -F <path to cloud-init file>: Cloud-Init userdata file to deploy OSM to OpenStack"
garciadeblase990f662018-05-18 11:43:39 +020046 echo -e " -D <devops path> use local devops installation path"
Mike Marchettib8420852018-09-13 13:45:06 -040047 echo -e " -w <work dir> Location to store runtime installation"
Mike Marchetti13d76c82018-09-19 15:00:36 -040048 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020049 echo -e " -l: LXD cloud yaml file"
50 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020051 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000052 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
53 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
54 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas0bc87522021-10-20 22:16:17 +020055 echo -e " --debug: debug mode"
garciadeblas9a510862021-04-21 14:15:56 +020056 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
garciadeblas0bc87522021-10-20 22:16:17 +020057 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
David Garcia79f4f532020-04-07 12:59:34 +020058 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblasa3e26612018-05-30 17:58:55 +020059 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
Mike Marchettib8420852018-09-13 13:45:06 -040060 echo -e " --nojuju: do not juju, assumes already installed"
61 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
62 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
63 echo -e " --nohostclient: do not install the osmclient"
garciadeblase990f662018-05-18 11:43:39 +020064 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
65 echo -e " --source: install OSM from source code using the latest stable tag"
garciadeblasd8bc5c32018-05-09 17:37:56 +020066 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
Mike Marchettida8a9c42018-10-01 15:25:15 -040067 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
romeromonser599d5e22020-03-06 10:23:29 +010068 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020069 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblasd8bc5c32018-05-09 17:37:56 +020070 echo -e " --showopts: print chosen options and exit (only for debugging)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020071 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
72 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
73 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020074 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
aticig5d19ac22022-05-06 13:46:22 +030075 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020076 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020077 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
78 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
David Garcia4bd2bf02021-05-05 19:01:43 +020079 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020080 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
beierlmf2782c52020-11-05 17:04:05 -050081 echo -e " [--tag]: Docker image tag. (--charmed option)"
82 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
garciadeblas0bc87522021-10-20 22:16:17 +020083 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020084}
85
Mike Marchettib8420852018-09-13 13:45:06 -040086# takes a juju/accounts.yaml file and returns the password specific
Adam Israel8232e562018-11-21 16:47:45 -050087# for a controller. I wrote this using only bash tools to minimize
Mike Marchettib8420852018-09-13 13:45:06 -040088# additions of other packages
89function parse_juju_password {
garciadeblas0bc87522021-10-20 22:16:17 +020090 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
91 password_file="${HOME}/.local/share/juju/accounts.yaml"
92 local controller_name=$1
93 local s='[[:space:]]*' w='[a-zA-Z0-9_-]*' fs=$(echo @|tr @ '\034')
94 sed -ne "s|^\($s\):|\1|" \
95 -e "s|^\($s\)\($w\)$s:$s[\"']\(.*\)[\"']$s\$|\1$fs\2$fs\3|p" \
96 -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p" $password_file |
97 awk -F$fs -v controller=$controller_name '{
98 indent = length($1)/2;
99 vname[indent] = $2;
100 for (i in vname) {if (i > indent) {delete vname[i]}}
101 if (length($3) > 0) {
102 vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
103 if (match(vn,controller) && match($2,"password")) {
104 printf("%s",$3);
105 }
106 }
107 }'
108 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
109}
110
111function set_vca_variables() {
112 OSM_VCA_CLOUDNAME="lxd-cloud"
113 [ -n "$OSM_VCA_HOST" ] && OSM_VCA_CLOUDNAME="localhost"
114 if [ -z "$OSM_VCA_HOST" ]; then
115 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_STACK_NAME"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
116 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
117 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
118 fi
119 if [ -z "$OSM_VCA_SECRET" ]; then
120 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $OSM_STACK_NAME)
121 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $CONTROLLER_NAME)
122 [ -z "$OSM_VCA_SECRET" ] && FATAL "Cannot obtain juju secret"
123 fi
124 if [ -z "$OSM_VCA_PUBKEY" ]; then
125 OSM_VCA_PUBKEY=$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)
126 [ -z "$OSM_VCA_PUBKEY" ] && FATAL "Cannot obtain juju public key"
127 fi
128 if [ -z "$OSM_VCA_CACERT" ]; then
129 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $OSM_STACK_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
130 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $CONTROLLER_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
131 [ -z "$OSM_VCA_CACERT" ] && FATAL "Cannot obtain juju CA certificate"
132 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400133}
134
Benjamin Diazba2cca92018-11-08 21:07:15 -0300135function generate_secret() {
garciadeblas0bc87522021-10-20 22:16:17 +0200136 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Benjamin Diazba2cca92018-11-08 21:07:15 -0300137 head /dev/urandom | tr -dc A-Za-z0-9 | head -c 32
garciadeblas0bc87522021-10-20 22:16:17 +0200138 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
calvinosanc10c82da02020-08-17 11:45:15 +0200139}
140
beierlm2ce2b002021-12-07 16:02:22 -0500141function check_packages() {
142 NEEDED_PACKAGES="$1"
143 echo -e "Checking required packages: ${NEEDED_PACKAGES}"
144 for PACKAGE in ${NEEDED_PACKAGES} ; do
garciadeblas835088e2022-01-28 11:25:18 +0100145 dpkg -L ${PACKAGE}
beierlm2ce2b002021-12-07 16:02:22 -0500146 if [ $? -ne 0 ]; then
garciadeblas835088e2022-01-28 11:25:18 +0100147 echo -e "Package ${PACKAGE} is not installed."
148 echo -e "Updating apt-cache ..."
beierlm2ce2b002021-12-07 16:02:22 -0500149 sudo apt-get update
garciadeblas835088e2022-01-28 11:25:18 +0100150 echo -e "Installing ${PACKAGE} ..."
beierlm2ce2b002021-12-07 16:02:22 -0500151 sudo apt-get install -y ${PACKAGE} || FATAL "failed to install ${PACKAGE}"
152 fi
153 done
154 echo -e "Required packages are present: ${NEEDED_PACKAGES}"
155}
156
garciadeblasd8bc5c32018-05-09 17:37:56 +0200157function ask_user(){
158 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
159 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
160 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
garciadeblas0bc87522021-10-20 22:16:17 +0200161 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200162 read -e -p "$1" USER_CONFIRMATION
163 while true ; do
164 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
165 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
166 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
167 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
168 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
169 done
garciadeblas0bc87522021-10-20 22:16:17 +0200170 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200171}
172
garciadeblasd8bc5c32018-05-09 17:37:56 +0200173function install_osmclient(){
garciadeblas0bc87522021-10-20 22:16:17 +0200174 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200175 CLIENT_RELEASE=${RELEASE#"-R "}
176 CLIENT_REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
177 CLIENT_REPOSITORY=${REPOSITORY#"-r "}
garciadeblasd8bc5c32018-05-09 17:37:56 +0200178 CLIENT_REPOSITORY_BASE=${REPOSITORY_BASE#"-u "}
179 key_location=$CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE/$CLIENT_REPOSITORY_KEY
garciadeblas0bc87522021-10-20 22:16:17 +0200180 curl $key_location | sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add -
garciadeblas078f5982019-11-27 15:06:06 +0100181 sudo add-apt-repository -y "deb [arch=amd64] $CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE $CLIENT_REPOSITORY osmclient IM"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200182 sudo apt-get update
garciadeblas078f5982019-11-27 15:06:06 +0100183 sudo apt-get install -y python3-pip
184 sudo -H LC_ALL=C python3 -m pip install -U pip
garciadeblasa9954892020-01-22 16:05:05 +0100185 sudo -H LC_ALL=C python3 -m pip install -U python-magic pyangbind verboselogs
garciadeblasda89ee72019-11-28 02:19:59 +0100186 sudo apt-get install -y python3-osm-im python3-osmclient
beierlm920d7562021-04-21 05:13:53 -0400187 if [ -f /usr/lib/python3/dist-packages/osm_im/requirements.txt ]; then
beierlm021b3072021-04-27 14:33:24 -0400188 python3 -m pip install -r /usr/lib/python3/dist-packages/osm_im/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400189 fi
190 if [ -f /usr/lib/python3/dist-packages/osmclient/requirements.txt ]; then
garciadeblas56005542022-08-29 14:56:02 +0200191 sudo apt-get install -y libcurl4-openssl-dev libssl-dev libmagic1
beierlm021b3072021-04-27 14:33:24 -0400192 python3 -m pip install -r /usr/lib/python3/dist-packages/osmclient/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400193 fi
garciadeblasd8bc5c32018-05-09 17:37:56 +0200194 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_HOSTNAME=`lxc list | awk '($2=="SO-ub"){print $6}'`
195 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_RO_HOSTNAME=`lxc list | awk '($2=="RO"){print $6}'`
garciadeblasd8bc5c32018-05-09 17:37:56 +0200196 echo -e "\nOSM client installed"
garciadeblasc3226982018-11-27 11:32:47 +0100197 if [ -z "$INSTALL_LIGHTWEIGHT" ]; then
198 echo -e "You might be interested in adding the following OSM client env variables to your .bashrc file:"
199 echo " export OSM_HOSTNAME=${OSM_HOSTNAME}"
200 echo " export OSM_RO_HOSTNAME=${OSM_RO_HOSTNAME}"
201 else
202 echo -e "OSM client assumes that OSM host is running in localhost (127.0.0.1)."
203 echo -e "In case you want to interact with a different OSM host, you will have to configure this env variable in your .bashrc file:"
204 echo " export OSM_HOSTNAME=<OSM_host>"
205 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200206 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200207 return 0
208}
209
garciadeblas453d4582020-12-16 19:03:10 +0100210function docker_login() {
garciadeblas0bc87522021-10-20 22:16:17 +0200211 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100212 echo "Docker login"
garciadeblas0bc87522021-10-20 22:16:17 +0200213 [ -z "${DEBUG_INSTALL}" ] || DEBUG "Docker registry user: ${DOCKER_REGISTRY_USER}"
214 sg docker -c "docker login -u ${DOCKER_REGISTRY_USER} -p ${DOCKER_REGISTRY_PASSWORD} --password-stdin"
215 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100216}
217
garciadeblasd8bc5c32018-05-09 17:37:56 +0200218function generate_docker_images() {
garciadeblas0bc87522021-10-20 22:16:17 +0200219 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200220 echo "Pulling and generating docker images"
garciadeblas453d4582020-12-16 19:03:10 +0100221 [ -n "${DOCKER_REGISTRY_URL}" ] && docker_login
Michael Marchettiee374142018-08-02 22:47:16 +0200222
garciadeblas7f1e1042020-11-30 14:07:03 +0000223 echo "Pulling docker images"
lavado60216242018-10-10 23:44:28 +0200224
garciadeblas0e596bc2018-05-28 16:04:42 +0200225 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q KAFKA ; then
226 sg docker -c "docker pull wurstmeister/zookeeper" || FATAL "cannot get zookeeper docker image"
Benjamin Diazaa0af712018-10-04 14:02:34 -0300227 sg docker -c "docker pull wurstmeister/kafka:${KAFKA_TAG}" || FATAL "cannot get kafka docker image"
garciadeblas0e596bc2018-05-28 16:04:42 +0200228 fi
Mike Marchettida8a9c42018-10-01 15:25:15 -0400229
lavado60216242018-10-10 23:44:28 +0200230 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS ; then
231 sg docker -c "docker pull prom/prometheus:${PROMETHEUS_TAG}" || FATAL "cannot get prometheus docker image"
232 fi
233
garciadeblasfc5bb142019-12-10 10:49:12 +0100234 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS-CADVISOR ; then
235 sg docker -c "docker pull google/cadvisor:${PROMETHEUS_CADVISOR_TAG}" || FATAL "cannot get prometheus cadvisor docker image"
236 fi
237
lavado6ad812e2019-11-29 10:58:58 -0500238 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q GRAFANA ; then
239 sg docker -c "docker pull grafana/grafana:${GRAFANA_TAG}" || FATAL "cannot get grafana docker image"
garciadeblas0ab16612022-02-22 14:23:57 +0100240 sg docker -c "docker pull kiwigrid/k8s-sidecar:${KIWIGRID_K8S_SIDECAR_TAG}" || FATAL "cannot get kiwigrid k8s-sidecar docker image"
garciadeblasfc5bb142019-12-10 10:49:12 +0100241 fi
lavado6ad812e2019-11-29 10:58:58 -0500242
garciadeblas4a83e6e2018-12-04 14:55:09 +0100243 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NBI || echo $TO_REBUILD | grep -q KEYSTONE-DB ; then
lavado9a8df7c2018-10-24 09:35:34 -0500244 sg docker -c "docker pull mariadb:${KEYSTONEDB_TAG}" || FATAL "cannot get keystone-db docker image"
245 fi
246
garciadeblas4a83e6e2018-12-04 14:55:09 +0100247 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q RO ; then
248 sg docker -c "docker pull mysql:5" || FATAL "cannot get mysql docker image"
249 fi
250
Mike Marchettida8a9c42018-10-01 15:25:15 -0400251 if [ -n "$PULL_IMAGES" ]; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000252 echo "Pulling OSM docker images"
beierlmcca93642021-05-03 16:29:14 -0400253 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA osmclient; do
garciadeblas7f1e1042020-11-30 14:07:03 +0000254 module_lower=${module,,}
garciadeblas7f1e1042020-11-30 14:07:03 +0000255 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
256 continue
257 fi
beierlm920d7562021-04-21 05:13:53 -0400258 module_tag="${OSM_DOCKER_TAG}"
garciadeblas7f1e1042020-11-30 14:07:03 +0000259 if [ -n "${MODULE_DOCKER_TAG}" ] && echo $TO_REBUILD | grep -q $module ; then
260 module_tag="${MODULE_DOCKER_TAG}"
261 fi
beierlm920d7562021-04-21 05:13:53 -0400262 echo "Pulling ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag} docker image"
garciadeblas7f1e1042020-11-30 14:07:03 +0000263 sg docker -c "docker pull ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag}" || FATAL "cannot pull $module docker image"
264 done
vijaynag4b57d462020-06-08 14:23:10 +0000265 else
garciadeblas7f1e1042020-11-30 14:07:03 +0000266 _build_from=$COMMIT_ID
267 [ -z "$_build_from" ] && _build_from="latest"
268 echo "OSM Docker images generated from $_build_from"
garciadeblas0bc87522021-10-20 22:16:17 +0200269 LWTEMPDIR="$(mktemp -d -q --tmpdir "installosmlight.XXXXXX")"
270 trap 'rm -rf "${LWTEMPDIR}"' EXIT
beierlmcca93642021-05-03 16:29:14 -0400271 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA; do
garciadeblas7f1e1042020-11-30 14:07:03 +0000272 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q ${module} ; then
273 module_lower=${module,,}
garciadeblas7f1e1042020-11-30 14:07:03 +0000274 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
275 continue
276 fi
277 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/$module
278 git -C ${LWTEMPDIR}/${module} checkout ${COMMIT_ID}
279 sg docker -c "docker build ${LWTEMPDIR}/${module} -f ${LWTEMPDIR}/${module}/docker/Dockerfile -t ${DOCKER_USER}/${module_lower} --no-cache" || FATAL "cannot build ${module} docker image"
280 fi
281 done
282 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q osmclient; then
283 BUILD_ARGS+=(--build-arg REPOSITORY="$REPOSITORY")
284 BUILD_ARGS+=(--build-arg RELEASE="$RELEASE")
285 BUILD_ARGS+=(--build-arg REPOSITORY_KEY="$REPOSITORY_KEY")
286 BUILD_ARGS+=(--build-arg REPOSITORY_BASE="$REPOSITORY_BASE")
287 sg docker -c "docker build -t ${DOCKER_USER}/osmclient ${BUILD_ARGS[@]} -f $OSM_DEVOPS/docker/osmclient ."
vijaynag4b57d462020-06-08 14:23:10 +0000288 fi
garciadeblas7f1e1042020-11-30 14:07:03 +0000289 echo "Finished generation of docker images"
Mike Marchettib8420852018-09-13 13:45:06 -0400290 fi
lavado6ad812e2019-11-29 10:58:58 -0500291
garciadeblas7f1e1042020-11-30 14:07:03 +0000292 echo "Finished pulling and generating docker images"
garciadeblas0bc87522021-10-20 22:16:17 +0200293 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200294}
295
garciadeblas5b857d32018-05-24 18:37:58 +0200296function cmp_overwrite() {
garciadeblas0bc87522021-10-20 22:16:17 +0200297 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas5b857d32018-05-24 18:37:58 +0200298 file1="$1"
299 file2="$2"
300 if ! $(cmp "${file1}" "${file2}" >/dev/null 2>&1); then
301 if [ -f "${file2}" ]; then
Mike Marchettib8420852018-09-13 13:45:06 -0400302 ask_user "The file ${file2} already exists. Overwrite (y/N)? " n && cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200303 else
Mike Marchettib8420852018-09-13 13:45:06 -0400304 cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200305 fi
306 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200307 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400308}
309
310function generate_k8s_manifest_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200311 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
beierlma4a37f72020-06-26 12:55:01 -0400312 #Kubernetes resources
garciadeblas0bc87522021-10-20 22:16:17 +0200313 sudo cp -bR ${OSM_DEVOPS}/installers/docker/osm_pods $OSM_DOCKER_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200314 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400315}
316
garciadeblasd8bc5c32018-05-09 17:37:56 +0200317function generate_docker_env_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200318 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200319 echo "Doing a backup of existing env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200320 sudo cp $OSM_DOCKER_WORK_DIR/keystone-db.env{,~}
321 sudo cp $OSM_DOCKER_WORK_DIR/keystone.env{,~}
322 sudo cp $OSM_DOCKER_WORK_DIR/lcm.env{,~}
323 sudo cp $OSM_DOCKER_WORK_DIR/mon.env{,~}
324 sudo cp $OSM_DOCKER_WORK_DIR/nbi.env{,~}
325 sudo cp $OSM_DOCKER_WORK_DIR/pol.env{,~}
326 sudo cp $OSM_DOCKER_WORK_DIR/ro-db.env{,~}
327 sudo cp $OSM_DOCKER_WORK_DIR/ro.env{,~}
garciadeblas7b53d262022-11-04 23:18:48 +0100328 if [ -n "${INSTALL_NGSA}" ]; then
329 sudo cp $OSM_DOCKER_WORK_DIR/ngsa.env{,~}
330 fi
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200331
garciadeblasd8bc5c32018-05-09 17:37:56 +0200332 echo "Generating docker env files"
Benjamin Diazba2cca92018-11-08 21:07:15 -0300333 # LCM
334 if [ ! -f $OSM_DOCKER_WORK_DIR/lcm.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200335 echo "OSMLCM_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300336 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400337
Benjamin Diazba2cca92018-11-08 21:07:15 -0300338 if ! grep -Fq "OSMLCM_VCA_HOST" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200339 echo "OSMLCM_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300340 else
garciadeblas0bc87522021-10-20 22:16:17 +0200341 sudo sed -i "s|OSMLCM_VCA_HOST.*|OSMLCM_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300342 fi
343
344 if ! grep -Fq "OSMLCM_VCA_SECRET" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200345 echo "OSMLCM_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300346 else
garciadeblas0bc87522021-10-20 22:16:17 +0200347 sudo sed -i "s|OSMLCM_VCA_SECRET.*|OSMLCM_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300348 fi
349
garciadeblasaa3ddf42019-04-04 19:04:32 +0200350 if ! grep -Fq "OSMLCM_VCA_PUBKEY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200351 echo "OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200352 else
garciadeblas0bc87522021-10-20 22:16:17 +0200353 sudo sed -i "s|OSMLCM_VCA_PUBKEY.*|OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200354 fi
355
Adam Israelbe7676a2019-10-02 16:10:53 -0400356 if ! grep -Fq "OSMLCM_VCA_CACERT" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200357 echo "OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400358 else
garciadeblas0bc87522021-10-20 22:16:17 +0200359 sudo sed -i "s|OSMLCM_VCA_CACERT.*|OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400360 fi
Benjamin Diazba2cca92018-11-08 21:07:15 -0300361
David Garcia6cbfee12020-10-23 10:40:20 +0200362 if [ -n "$OSM_VCA_APIPROXY" ]; then
363 if ! grep -Fq "OSMLCM_VCA_APIPROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200364 echo "OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200365 else
garciadeblas0bc87522021-10-20 22:16:17 +0200366 sudo sed -i "s|OSMLCM_VCA_APIPROXY.*|OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200367 fi
Adam Israel5ddc97f2019-09-03 18:11:12 -0400368 fi
369
garciadeblasa2e41842019-12-18 11:05:24 +0100370 if ! grep -Fq "OSMLCM_VCA_ENABLEOSUPGRADE" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200371 echo "# OSMLCM_VCA_ENABLEOSUPGRADE=false" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100372 fi
373
374 if ! grep -Fq "OSMLCM_VCA_APTMIRROR" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200375 echo "# OSMLCM_VCA_APTMIRROR=http://archive.ubuntu.com/ubuntu/" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100376 fi
377
David Garcia79f4f532020-04-07 12:59:34 +0200378 if ! grep -Fq "OSMLCM_VCA_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200379 echo "OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200380 else
garciadeblas0bc87522021-10-20 22:16:17 +0200381 sudo sed -i "s|OSMLCM_VCA_CLOUD.*|OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200382 fi
383
beierlma4a37f72020-06-26 12:55:01 -0400384 if ! grep -Fq "OSMLCM_VCA_K8S_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200385 echo "OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400386 else
garciadeblas0bc87522021-10-20 22:16:17 +0200387 sudo sed -i "s|OSMLCM_VCA_K8S_CLOUD.*|OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400388 fi
garciadeblasfa3eb332022-11-15 14:11:56 +0100389 if [ -n "${OSM_BEHIND_PROXY}" ]; then
390 if ! grep -Fq "HTTP_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
391 echo "HTTP_PROXY=${HTTP_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
392 else
393 sudo sed -i "s|HTTP_PROXY.*|HTTP_PROXY=${HTTP_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
394 fi
395 if ! grep -Fq "HTTPS_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
396 echo "HTTPS_PROXY=${HTTPS_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
397 else
398 sudo sed -i "s|HTTPS_PROXY.*|HTTPS_PROXY=${HTTPS_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
399 fi
400 if ! grep -Fq "NO_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
401 echo "NO_PROXY=${NO_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
402 else
403 sudo sed -i "s|NO_PROXY.*|NO_PROXY=${NO_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
404 fi
405 fi
beierlma4a37f72020-06-26 12:55:01 -0400406
Benjamin Diazba2cca92018-11-08 21:07:15 -0300407 # RO
408 MYSQL_ROOT_PASSWORD=$(generate_secret)
Mike Marchettib8420852018-09-13 13:45:06 -0400409 if [ ! -f $OSM_DOCKER_WORK_DIR/ro-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200410 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro-db.env
garciadeblas5b857d32018-05-24 18:37:58 +0200411 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400412 if [ ! -f $OSM_DOCKER_WORK_DIR/ro.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200413 echo "RO_DB_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro.env
garciadeblas5b857d32018-05-24 18:37:58 +0200414 fi
tierno9ec1fe92020-11-25 13:16:51 +0000415 if ! grep -Fq "OSMRO_DATABASE_COMMONKEY" $OSM_DOCKER_WORK_DIR/ro.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200416 echo "OSMRO_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ro.env
tierno9ec1fe92020-11-25 13:16:51 +0000417 fi
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100418
Benjamin Diazba2cca92018-11-08 21:07:15 -0300419 # Keystone
Benjamin Diazba2cca92018-11-08 21:07:15 -0300420 KEYSTONE_DB_PASSWORD=$(generate_secret)
Eduardo Sousac50ed8f2019-04-08 17:17:54 +0100421 SERVICE_PASSWORD=$(generate_secret)
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100422 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200423 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone-db.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100424 fi
425 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200426 echo "ROOT_DB_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone.env
427 echo "KEYSTONE_DB_PASSWORD=${KEYSTONE_DB_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
428 echo "SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100429 fi
430
Benjamin Diazba2cca92018-11-08 21:07:15 -0300431 # NBI
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100432 if [ ! -f $OSM_DOCKER_WORK_DIR/nbi.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200433 echo "OSMNBI_AUTHENTICATION_SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/nbi.env
434 echo "OSMNBI_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/nbi.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100435 fi
436
Benjamin Diazba2cca92018-11-08 21:07:15 -0300437 # MON
438 if [ ! -f $OSM_DOCKER_WORK_DIR/mon.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200439 echo "OSMMON_KEYSTONE_SERVICE_PASSWORD=${SERVICE_PASSWORD}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
440 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
441 echo "OSMMON_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/mon" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300442 fi
443
444 if ! grep -Fq "OS_NOTIFIER_URI" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100445 echo "OS_NOTIFIER_URI=http://${OSM_DEFAULT_IP}:8662" |sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300446 else
garciadeblas45ab04c2022-11-25 10:59:03 +0100447 sudo sed -i "s|OS_NOTIFIER_URI.*|OS_NOTIFIER_URI=http://$OSM_DEFAULT_IP:8662|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300448 fi
449
450 if ! grep -Fq "OSMMON_VCA_HOST" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200451 echo "OSMMON_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300452 else
garciadeblas0bc87522021-10-20 22:16:17 +0200453 sudo sed -i "s|OSMMON_VCA_HOST.*|OSMMON_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300454 fi
455
456 if ! grep -Fq "OSMMON_VCA_SECRET" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200457 echo "OSMMON_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300458 else
garciadeblas0bc87522021-10-20 22:16:17 +0200459 sudo sed -i "s|OSMMON_VCA_SECRET.*|OSMMON_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300460 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400461
Adam Israel6d8adf32019-12-05 15:46:54 -0500462 if ! grep -Fq "OSMMON_VCA_CACERT" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200463 echo "OSMMON_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500464 else
garciadeblas0bc87522021-10-20 22:16:17 +0200465 sudo sed -i "s|OSMMON_VCA_CACERT.*|OSMMON_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500466 fi
467
Benjamin Diaz04560882019-02-26 17:25:07 -0300468 # POL
469 if [ ! -f $OSM_DOCKER_WORK_DIR/pol.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200470 echo "OSMPOL_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/pol" | sudo tee -a $OSM_DOCKER_WORK_DIR/pol.env
Benjamin Diaz04560882019-02-26 17:25:07 -0300471 fi
472
garciadeblas7b53d262022-11-04 23:18:48 +0100473 # NG-SA
474 if [ -n "${INSTALL_NGSA}" ] && [ ! -f $OSM_DOCKER_WORK_DIR/ngsa.env ]; then
475 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ngsa.env
476 fi
477
garciadeblasd8bc5c32018-05-09 17:37:56 +0200478 echo "Finished generation of docker env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200479 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530480}
481
482#creates secrets from env files which will be used by containers
483function kube_secrets(){
garciadeblas0bc87522021-10-20 22:16:17 +0200484 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530485 kubectl create ns $OSM_STACK_NAME
486 kubectl create secret generic lcm-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/lcm.env
487 kubectl create secret generic mon-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/mon.env
488 kubectl create secret generic nbi-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/nbi.env
489 kubectl create secret generic ro-db-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro-db.env
490 kubectl create secret generic ro-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro.env
491 kubectl create secret generic keystone-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/keystone.env
vijaynag8339ed22019-07-25 17:10:58 +0530492 kubectl create secret generic pol-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/pol.env
garciadeblas7b53d262022-11-04 23:18:48 +0100493 if [ -n "${INSTALL_NGSA}" ]; then
494 kubectl create secret generic ngsa-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ngsa.env
495 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200496 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasf6ed60c2020-07-08 14:30:29 +0000497}
498
499#deploys osm pods and services
500function deploy_osm_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200501 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530502 kubectl apply -n $OSM_STACK_NAME -f $OSM_K8S_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200503 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530504}
505
David Garciaa1376012020-10-19 15:42:42 +0200506#deploy charmed services
507function deploy_charmed_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200508 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
David Garciaa1376012020-10-19 15:42:42 +0200509 juju add-model $OSM_STACK_NAME $OSM_VCA_K8S_CLOUDNAME
garciadeblas37a7ee52023-11-21 13:39:06 +0100510 juju deploy ch:mongodb-k8s -m $OSM_STACK_NAME --channel latest/stable
garciadeblas0bc87522021-10-20 22:16:17 +0200511 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
David Garciaa1376012020-10-19 15:42:42 +0200512}
513
magnussonl1bbe9452020-02-25 13:43:17 +0100514function deploy_osm_pla_service() {
garciadeblas0bc87522021-10-20 22:16:17 +0200515 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
magnussonl1bbe9452020-02-25 13:43:17 +0100516 # corresponding to deploy_osm_services
517 kubectl apply -n $OSM_STACK_NAME -f $OSM_DOCKER_WORK_DIR/osm_pla
garciadeblas0bc87522021-10-20 22:16:17 +0200518 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonser599d5e22020-03-06 10:23:29 +0100519}
520
garciadeblas7b53d262022-11-04 23:18:48 +0100521function install_osm_ngsa_service() {
522 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd2d00c72022-11-25 17:21:46 +0100523 $OSM_DEVOPS/installers/install_ngsa.sh -d ${OSM_HELM_WORK_DIR} -D ${OSM_DEVOPS} -t ${OSM_DOCKER_TAG} ${DEBUG_INSTALL} || \
garciadeblas7b53d262022-11-04 23:18:48 +0100524 FATAL_TRACK install_osm_ngsa_service "install_ngsa.sh failed"
525 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
526}
527
vijaynag8339ed22019-07-25 17:10:58 +0530528function parse_yaml() {
garciadeblas0bc87522021-10-20 22:16:17 +0200529 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530530 TAG=$1
garciadeblas7f1e1042020-11-30 14:07:03 +0000531 shift
532 services=$@
533 for module in $services; do
534 if [ "$module" == "pla" ]; then
535 if [ -n "$INSTALL_PLA" ]; then
garciadeblas7b53d262022-11-04 23:18:48 +0100536 echo "Updating K8s manifest file from opensourcemano\/pla:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/pla:${TAG}"
garciadeblas0bc87522021-10-20 22:16:17 +0200537 sudo sed -i "s#opensourcemano/pla:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/pla:${TAG}#g" ${OSM_DOCKER_WORK_DIR}/osm_pla/pla.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000538 fi
539 else
garciadeblas7b53d262022-11-04 23:18:48 +0100540 image=${module}
541 if [ "$module" == "ng-prometheus" ]; then
542 image="prometheus"
543 fi
544 echo "Updating K8s manifest file from opensourcemano\/${image}:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/${image}:${TAG}"
545 sudo sed -i "s#opensourcemano/${image}:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/${image}:${TAG}#g" ${OSM_K8S_WORK_DIR}/${module}.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000546 fi
vijaynag8339ed22019-07-25 17:10:58 +0530547 done
garciadeblas0bc87522021-10-20 22:16:17 +0200548 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas7f1e1042020-11-30 14:07:03 +0000549}
550
551function update_manifest_files() {
garciadeblas7b53d262022-11-04 23:18:48 +0100552 osm_services="nbi lcm ro pol mon ng-ui keystone pla prometheus ng-prometheus"
garciadeblas7f1e1042020-11-30 14:07:03 +0000553 list_of_services=""
554 for module in $osm_services; do
555 module_upper="${module^^}"
garciadeblas7f1e1042020-11-30 14:07:03 +0000556 if ! echo $TO_REBUILD | grep -q $module_upper ; then
557 list_of_services="$list_of_services $module"
558 fi
559 done
garciadeblas89c5f552022-11-24 20:16:57 +0100560 if [ ! "$OSM_DOCKER_TAG" == "13" ]; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000561 parse_yaml $OSM_DOCKER_TAG $list_of_services
562 fi
563 if [ -n "$MODULE_DOCKER_TAG" ]; then
564 parse_yaml $MODULE_DOCKER_TAG $list_of_services_to_rebuild
565 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100566 # The manifest for prometheus is prometheus.yaml or ng-prometheus.yaml, depending on the installation option
567 if [ -n "$INSTALL_NGSA" ]; then
568 sudo rm -f ${OSM_K8S_WORK_DIR}/prometheus.yaml
569 else
570 sudo rm -f ${OSM_K8S_WORK_DIR}/ng-prometheus.yaml
571 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200572 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530573}
574
575function namespace_vol() {
garciadeblas0bc87522021-10-20 22:16:17 +0200576 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas7b53d262022-11-04 23:18:48 +0100577 # List of services with a volume mounted in path /var/lib/osm
578 osm_services="mysql"
vijaynag8339ed22019-07-25 17:10:58 +0530579 for osm in $osm_services; do
garciadeblas7b53d262022-11-04 23:18:48 +0100580 if [ -f "$OSM_K8S_WORK_DIR/$osm.yaml" ] ; then
581 sudo sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_K8S_WORK_DIR/$osm.yaml
582 fi
vijaynag8339ed22019-07-25 17:10:58 +0530583 done
garciadeblas0bc87522021-10-20 22:16:17 +0200584 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas6c66abf2018-05-16 14:46:19 +0200585}
586
garciadeblase92a18d2020-07-03 16:24:23 +0000587function add_local_k8scluster() {
garciadeblas0bc87522021-10-20 22:16:17 +0200588 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblase92a18d2020-07-03 16:24:23 +0000589 /usr/bin/osm --all-projects vim-create \
590 --name _system-osm-vim \
591 --account_type dummy \
592 --auth_url http://dummy \
593 --user osm --password osm --tenant osm \
594 --description "dummy" \
595 --config '{management_network_name: mgmt}'
596 /usr/bin/osm --all-projects k8scluster-add \
597 --creds ${HOME}/.kube/config \
598 --vim _system-osm-vim \
599 --k8s-nets '{"net1": null}' \
600 --version '1.15' \
601 --description "OSM Internal Cluster" \
602 _system-osm-k8s
garciadeblas0bc87522021-10-20 22:16:17 +0200603 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblase92a18d2020-07-03 16:24:23 +0000604}
605
garciadeblas0bc87522021-10-20 22:16:17 +0200606function configure_apt_proxy() {
607 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
608 OSM_APT_PROXY=$1
609 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
610 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
611 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
612 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
613Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
614EOF"
615 else
616 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
617 fi
618 sudo apt-get update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas4d89c372021-11-25 11:57:18 +0100619 track prereq apt_proxy_configured_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200620 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
621}
622
garciadeblasfa3eb332022-11-15 14:11:56 +0100623function ask_proceed() {
garciadeblas0bc87522021-10-20 22:16:17 +0200624 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasadcf95e2022-01-28 17:15:39 +0100625
garciadeblas0bc87522021-10-20 22:16:17 +0200626 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will do the following
627 1. Install and configure LXD
628 2. Install juju
629 3. Install docker CE
630 4. Disable swap space
631 5. Install and initialize Kubernetes
632 as pre-requirements.
633 Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
garciadeblasfa3eb332022-11-15 14:11:56 +0100634
635 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
636}
637
638function check_osm_behind_proxy() {
639 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
640
641 export OSM_BEHIND_PROXY=""
642 export OSM_PROXY_ENV_VARIABLES=""
643 [ -n "${http_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "http_proxy=${http_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} http_proxy"
644 [ -n "${https_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${https_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} https_proxy"
645 [ -n "${HTTP_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "HTTP_PROXY=${HTTP_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTP_PROXY"
646 [ -n "${HTTPS_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${HTTPS_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTPS_PROXY"
647 [ -n "${no_proxy}" ] && echo "no_proxy=${no_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} no_proxy"
648 [ -n "${NO_PROXY}" ] && echo "NO_PROXY=${NO_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} NO_PROXY"
649
650 echo "OSM_BEHIND_PROXY=${OSM_BEHIND_PROXY}"
651 echo "OSM_PROXY_ENV_VARIABLES=${OSM_PROXY_ENV_VARIABLES}"
652
653 if [ -n "${OSM_BEHIND_PROXY}" ]; then
654 [ -z "$ASSUME_YES" ] && ! ask_user "
655The following env variables have been found for the current user:
656${OSM_PROXY_ENV_VARIABLES}.
657
658This suggests that this machine is behind a proxy and a special configuration is required.
659The installer will install Docker CE, LXD and Juju to work behind a proxy using those
660env variables.
661
662Take into account that the installer uses apt, curl, wget, docker, lxd, juju and snap.
663Depending on the program, the env variables to work behind a proxy might be different
664(e.g. http_proxy vs HTTP_PROXY).
665
666For that reason, it is strongly recommended that at least http_proxy, https_proxy, HTTP_PROXY
667and HTTPS_PROXY are defined.
668
669Finally, some of the programs (apt, snap) those programs are run as sudoer, requiring that
670those env variables are also set for root user. If you are not sure whether those variables
671are configured for the root user, you can stop the installation now.
672
673Do you want to proceed with the installation (Y/n)? " y && echo "Cancelled!" && exit 1
674 else
675 echo "This machine is not behind a proxy"
676 fi
677
678 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
679}
680
681function find_devops_folder() {
682 if [ -z "$OSM_DEVOPS" ]; then
683 if [ -n "$TEST_INSTALLER" ]; then
684 echo -e "\nUsing local devops repo for OSM installation"
685 OSM_DEVOPS="$(dirname $(realpath $(dirname $0)))"
686 else
687 echo -e "\nCreating temporary dir for OSM installation"
688 OSM_DEVOPS="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
689 trap 'rm -rf "$OSM_DEVOPS"' EXIT
690 git clone https://osm.etsi.org/gerrit/osm/devops.git $OSM_DEVOPS
691 fi
692 fi
693}
694
695function install_osm() {
696 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
697
698 trap ctrl_c INT
699
700 # TODO: move this under start
701 [ -n "$DOCKER_REGISTRY_URL" ] && parse_docker_registry_url
702
703 check_osm_behind_proxy
704 track checks proxy_ok
705
706 check_packages "git wget curl tar snapd"
707
708 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
709
710 find_devops_folder
711
712 # TODO: the use of stacks come from docker-compose. We should probably remove
713 [ "${OSM_STACK_NAME}" == "osm" ] || OSM_DOCKER_WORK_DIR="$OSM_WORK_DIR/stack/$OSM_STACK_NAME"
714
715 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
716
717 track checks checkingroot_ok
718 [ "$USER" == "root" ] && FATAL "You are running the installer as root. The installer is prepared to be executed as a normal user with sudo privileges."
719 track checks noroot_ok
720
721 ask_proceed
garciadeblas4d89c372021-11-25 11:57:18 +0100722 track checks proceed_ok
vijaynag8339ed22019-07-25 17:10:58 +0530723
garciadeblas0bc87522021-10-20 22:16:17 +0200724 echo "Installing OSM"
725
726 echo "Determining IP address of the interface with the default route"
garciadeblas45ab04c2022-11-25 10:59:03 +0100727 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
728 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
729 [ -z "$OSM_DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
730 OSM_DEFAULT_IP=`ip -o -4 a s ${OSM_DEFAULT_IF} |awk '{split($4,a,"/"); print a[1]; exit}'`
731 [ -z "$OSM_DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
garciadeblas0bc87522021-10-20 22:16:17 +0200732
733 # configure apt proxy
734 [ -n "$APT_PROXY_URL" ] && configure_apt_proxy $APT_PROXY_URL
Mike Marchettib8420852018-09-13 13:45:06 -0400735
736 # if no host is passed in, we need to install lxd/juju, unless explicilty asked not to
David Garcia79f4f532020-04-07 12:59:34 +0200737 if [ -z "$OSM_VCA_HOST" ] && [ -z "$INSTALL_NOLXD" ] && [ -z "$LXD_CLOUD_FILE" ]; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100738 LXD_INSTALL_OPTS="-D ${OSM_DEVOPS} -i ${OSM_DEFAULT_IF} ${DEBUG_INSTALL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100739 [ -n "${OSM_BEHIND_PROXY}" ] && LXD_INSTALL_OPTS="${LXD_INSTALL_OPTS} -P"
garciadeblas8fed1082022-08-29 11:25:02 +0200740 $OSM_DEVOPS/installers/install_lxd.sh ${LXD_INSTALL_OPTS} || FATAL_TRACK lxd "install_lxd.sh failed"
garciadeblasd41f5482018-05-25 10:25:06 +0200741 fi
David Garcia79f4f532020-04-07 12:59:34 +0200742
garciadeblas4d89c372021-11-25 11:57:18 +0100743 track prereq prereqok_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400744
garciadeblas95804f82021-11-08 23:02:01 +0100745 if [ ! -n "$INSTALL_NODOCKER" ]; then
746 DOCKER_CE_OPTS="-D ${OSM_DEVOPS} ${DEBUG_INSTALL}"
747 [ -n "${DOCKER_PROXY_URL}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -p ${DOCKER_PROXY_URL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100748 [ -n "${OSM_BEHIND_PROXY}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100749 $OSM_DEVOPS/installers/install_docker_ce.sh ${DOCKER_CE_OPTS} || FATAL_TRACK docker_ce "install_docker_ce.sh failed"
garciadeblas95804f82021-11-08 23:02:01 +0100750 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200751
garciadeblas4d89c372021-11-25 11:57:18 +0100752 track docker_ce docker_ce_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200753
754 echo "Creating folders for installation"
garciadeblas0bc87522021-10-20 22:16:17 +0200755 [ ! -d "$OSM_DOCKER_WORK_DIR" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR
756 [ ! -d "$OSM_DOCKER_WORK_DIR/osm_pla" -a -n "$INSTALL_PLA" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR/osm_pla
757 sudo cp -b $OSM_DEVOPS/installers/docker/cluster-config.yaml $OSM_DOCKER_WORK_DIR/cluster-config.yaml
David Garcia6cbfee12020-10-23 10:40:20 +0200758
garciadeblas45ab04c2022-11-25 10:59:03 +0100759 $OSM_DEVOPS/installers/install_kubeadm_cluster.sh -i ${OSM_DEFAULT_IP} -d ${OSM_DOCKER_WORK_DIR} -D ${OSM_DEVOPS} ${DEBUG_INSTALL} || \
garciadeblas4d89c372021-11-25 11:57:18 +0100760 FATAL_TRACK k8scluster "install_kubeadm_cluster.sh failed"
761 track k8scluster k8scluster_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200762
garciadeblas45ab04c2022-11-25 10:59:03 +0100763 JUJU_OPTS="-D ${OSM_DEVOPS} -s ${OSM_STACK_NAME} -i ${OSM_DEFAULT_IP} ${DEBUG_INSTALL} ${INSTALL_NOJUJU} ${INSTALL_CACHELXDIMAGES}"
garciadeblas0bc87522021-10-20 22:16:17 +0200764 [ -n "${OSM_VCA_HOST}" ] && JUJU_OPTS="$JUJU_OPTS -H ${OSM_VCA_HOST}"
765 [ -n "${LXD_CLOUD_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -l ${LXD_CLOUD_FILE}"
766 [ -n "${LXD_CRED_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -L ${LXD_CRED_FILE}"
767 [ -n "${CONTROLLER_NAME}" ] && JUJU_OPTS="$JUJU_OPTS -K ${CONTROLLER_NAME}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100768 [ -n "${OSM_BEHIND_PROXY}" ] && JUJU_OPTS="${JUJU_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100769 $OSM_DEVOPS/installers/install_juju.sh ${JUJU_OPTS} || FATAL_TRACK juju "install_juju.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200770 set_vca_variables
garciadeblas4d89c372021-11-25 11:57:18 +0100771 track juju juju_ok
Adam Israel5ddc97f2019-09-03 18:11:12 -0400772
Benjamin Diazba2cca92018-11-08 21:07:15 -0300773 if [ -z "$OSM_DATABASE_COMMONKEY" ]; then
774 OSM_DATABASE_COMMONKEY=$(generate_secret)
775 [ -z "OSM_DATABASE_COMMONKEY" ] && FATAL "Cannot generate common db secret"
776 fi
vijaynag8339ed22019-07-25 17:10:58 +0530777
David Garcia6cbfee12020-10-23 10:40:20 +0200778 # Deploy OSM services
Mike Marchettib8420852018-09-13 13:45:06 -0400779 [ -z "$DOCKER_NOBUILD" ] && generate_docker_images
garciadeblas4d89c372021-11-25 11:57:18 +0100780 track docker_images docker_images_ok
vijaynag8339ed22019-07-25 17:10:58 +0530781
garciadeblas0bc87522021-10-20 22:16:17 +0200782 generate_k8s_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100783 track osm_files manifest_files_ok
garciadeblasd8bc5c32018-05-09 17:37:56 +0200784 generate_docker_env_files
garciadeblas4d89c372021-11-25 11:57:18 +0100785 track osm_files env_files_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400786
garciadeblas0bc87522021-10-20 22:16:17 +0200787 deploy_charmed_services
garciadeblas4d89c372021-11-25 11:57:18 +0100788 track deploy_osm deploy_charmed_services_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200789 kube_secrets
garciadeblas4d89c372021-11-25 11:57:18 +0100790 track deploy_osm kube_secrets_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200791 update_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100792 track deploy_osm update_manifest_files_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200793 namespace_vol
garciadeblas4d89c372021-11-25 11:57:18 +0100794 track deploy_osm namespace_vol_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200795 deploy_osm_services
garciadeblas4d89c372021-11-25 11:57:18 +0100796 track deploy_osm deploy_osm_services_k8s_ok
garciadeblas7b53d262022-11-04 23:18:48 +0100797 if [ -n "$INSTALL_PLA" ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200798 # optional PLA install
799 deploy_osm_pla_service
garciadeblas4d89c372021-11-25 11:57:18 +0100800 track deploy_osm deploy_osm_pla_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200801 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200802 if [ -n "$INSTALL_K8S_MONITOR" ]; then
803 # install OSM MONITORING
804 install_k8s_monitoring
garciadeblas4d89c372021-11-25 11:57:18 +0100805 track deploy_osm install_k8s_monitoring_ok
vijaynag8339ed22019-07-25 17:10:58 +0530806 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100807 if [ -n "$INSTALL_NGSA" ]; then
808 # optional PLA install
809 install_osm_ngsa_service
810 track deploy_osm install_osm_ngsa_ok
811 fi
vijaynag8339ed22019-07-25 17:10:58 +0530812
Mike Marchettib8420852018-09-13 13:45:06 -0400813 [ -z "$INSTALL_NOHOSTCLIENT" ] && install_osmclient
garciadeblas4d89c372021-11-25 11:57:18 +0100814 track osmclient osmclient_ok
beierlma4a37f72020-06-26 12:55:01 -0400815
garciadeblas4a9adcd2020-07-03 15:32:05 +0000816 echo -e "Checking OSM health state..."
garciadeblas0bc87522021-10-20 22:16:17 +0200817 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_STACK_NAME} -k || \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100818 (echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
garciadeblas0bc87522021-10-20 22:16:17 +0200819 echo -e "Check OSM status with: kubectl -n ${OSM_STACK_NAME} get all" && \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100820 track healthchecks osm_unhealthy didnotconverge)
garciadeblas4d89c372021-11-25 11:57:18 +0100821 track healthchecks after_healthcheck_ok
vijaynag8339ed22019-07-25 17:10:58 +0530822
garciadeblas0bc87522021-10-20 22:16:17 +0200823 add_local_k8scluster
garciadeblas4d89c372021-11-25 11:57:18 +0100824 track final_ops add_local_k8scluster_ok
garciadeblase92a18d2020-07-03 16:24:23 +0000825
Gulsum Aticiaed2c6a2023-02-01 11:15:52 +0300826 arrange_docker_default_network_policy
Gulsum Atici2c0b0df2023-01-30 19:11:31 +0300827
garciadeblas89c5f552022-11-24 20:16:57 +0100828 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
garciadeblas6c66abf2018-05-16 14:46:19 +0200829 track end
garciadeblas0bc87522021-10-20 22:16:17 +0200830 sudo find /etc/osm
831 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200832 return 0
833}
834
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200835function install_to_openstack() {
garciadeblas0bc87522021-10-20 22:16:17 +0200836 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200837
838 if [ -z "$2" ]; then
839 FATAL "OpenStack installer requires a valid external network name"
840 fi
841
842 # Install Pip for Python3
garciadeblas0bc87522021-10-20 22:16:17 +0200843 sudo apt install -y python3-pip python3-venv
844 sudo -H LC_ALL=C python3 -m pip install -U pip
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200845
Antonio Marsico75a38c72020-12-21 17:29:42 +0100846 # Create a venv to avoid conflicts with the host installation
847 python3 -m venv $OPENSTACK_PYTHON_VENV
848
849 source $OPENSTACK_PYTHON_VENV/bin/activate
850
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100851 # Install Ansible, OpenStack client and SDK, latest openstack version supported is Train
Antonio Marsico75a38c72020-12-21 17:29:42 +0100852 python -m pip install -U wheel
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100853 python -m pip install -U "python-openstackclient<=4.0.2" "openstacksdk>=0.12.0,<=0.36.2" "ansible>=2.10,<2.11"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100854
855 # Install the Openstack cloud module (ansible>=2.10)
856 ansible-galaxy collection install openstack.cloud
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200857
858 export ANSIBLE_CONFIG="$OSM_DEVOPS/installers/openstack/ansible.cfg"
859
860 OSM_INSTALLER_ARGS="${REPO_ARGS[@]}"
861
Antonio Marsico75a38c72020-12-21 17:29:42 +0100862 ANSIBLE_VARS="external_network_name=$2 setup_volume=$3 server_name=$OPENSTACK_VM_NAME"
863
864 if [ -n "$OPENSTACK_SSH_KEY_FILE" ]; then
865 ANSIBLE_VARS+=" key_file=$OPENSTACK_SSH_KEY_FILE"
866 fi
867
868 if [ -n "$OPENSTACK_USERDATA_FILE" ]; then
869 ANSIBLE_VARS+=" userdata_file=$OPENSTACK_USERDATA_FILE"
870 fi
871
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200872 # Execute the Ansible playbook based on openrc or clouds.yaml
873 if [ -e "$1" ]; then
874 . $1
Antonio Marsico75a38c72020-12-21 17:29:42 +0100875 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
876 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200877 else
Antonio Marsico75a38c72020-12-21 17:29:42 +0100878 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
879 -e cloud_name=$1 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200880 fi
881
Antonio Marsico75a38c72020-12-21 17:29:42 +0100882 # Exit from venv
883 deactivate
884
garciadeblas0bc87522021-10-20 22:16:17 +0200885 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200886 return 0
887}
888
Gulsum Aticiaed2c6a2023-02-01 11:15:52 +0300889function arrange_docker_default_network_policy() {
890 echo -e "Fixing firewall so docker and LXD can share the same host without affecting each other."
891 sudo iptables -I DOCKER-USER -j ACCEPT
892 sudo iptables-save | sudo tee /etc/iptables/rules.v4
893 sudo ip6tables-save | sudo tee /etc/iptables/rules.v6
894}
895
romeromonsere366b1a2019-11-19 19:49:26 +0100896function install_k8s_monitoring() {
garciadeblas0bc87522021-10-20 22:16:17 +0200897 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
romeromonsere366b1a2019-11-19 19:49:26 +0100898 # install OSM monitoring
garciadeblas0bc87522021-10-20 22:16:17 +0200899 sudo chmod +x $OSM_DEVOPS/installers/k8s/*.sh
garciadeblas4d89c372021-11-25 11:57:18 +0100900 sudo $OSM_DEVOPS/installers/k8s/install_osm_k8s_monitoring.sh || FATAL_TRACK install_k8s_monitoring "k8s/install_osm_k8s_monitoring.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200901 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonsere366b1a2019-11-19 19:49:26 +0100902}
903
garciadeblasd8bc5c32018-05-09 17:37:56 +0200904function dump_vars(){
garciadeblas0bc87522021-10-20 22:16:17 +0200905 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
906 echo "APT_PROXY_URL=$APT_PROXY_URL"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200907 echo "DEVELOP=$DEVELOP"
garciadeblas0bc87522021-10-20 22:16:17 +0200908 echo "DEBUG_INSTALL=$DEBUG_INSTALL"
909 echo "DOCKER_NOBUILD=$DOCKER_NOBUILD"
910 echo "DOCKER_PROXY_URL=$DOCKER_PROXY_URL"
911 echo "DOCKER_REGISTRY_URL=$DOCKER_REGISTRY_URL"
912 echo "DOCKER_USER=$DOCKER_USER"
913 echo "INSTALL_CACHELXDIMAGES=$INSTALL_CACHELXDIMAGES"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200914 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
garciadeblas0bc87522021-10-20 22:16:17 +0200915 echo "INSTALL_K8S_MONITOR=$INSTALL_K8S_MONITOR"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200916 echo "INSTALL_LIGHTWEIGHT=$INSTALL_LIGHTWEIGHT"
garciadeblas0bc87522021-10-20 22:16:17 +0200917 echo "INSTALL_LXD=$INSTALL_LXD"
garciadeblas7b53d262022-11-04 23:18:48 +0100918 echo "INSTALL_NGSA=$INSTALL_NGSA"
garciadeblas0bc87522021-10-20 22:16:17 +0200919 echo "INSTALL_NODOCKER=$INSTALL_NODOCKER"
920 echo "INSTALL_NOJUJU=$INSTALL_NOJUJU"
921 echo "INSTALL_NOLXD=$INSTALL_NOLXD"
garciadeblas6c66abf2018-05-16 14:46:19 +0200922 echo "INSTALL_ONLY=$INSTALL_ONLY"
garciadeblas0bc87522021-10-20 22:16:17 +0200923 echo "INSTALL_PLA=$INSTALL_PLA"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200924 echo "INSTALL_TO_OPENSTACK=$INSTALL_TO_OPENSTACK"
garciadeblas0bc87522021-10-20 22:16:17 +0200925 echo "INSTALL_VIMEMU=$INSTALL_VIMEMU"
926 echo "NO_HOST_PORTS=$NO_HOST_PORTS"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200927 echo "OPENSTACK_PUBLIC_NET_NAME=$OPENSTACK_PUBLIC_NET_NAME"
928 echo "OPENSTACK_OPENRC_FILE_OR_CLOUD=$OPENSTACK_OPENRC_FILE_OR_CLOUD"
929 echo "OPENSTACK_ATTACH_VOLUME=$OPENSTACK_ATTACH_VOLUME"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100930 echo "OPENSTACK_SSH_KEY_FILE"="$OPENSTACK_SSH_KEY_FILE"
931 echo "OPENSTACK_USERDATA_FILE"="$OPENSTACK_USERDATA_FILE"
932 echo "OPENSTACK_VM_NAME"="$OPENSTACK_VM_NAME"
garciadeblas0bc87522021-10-20 22:16:17 +0200933 echo "OSM_DEVOPS=$OSM_DEVOPS"
934 echo "OSM_DOCKER_TAG=$OSM_DOCKER_TAG"
garciadeblas0cd9b882022-02-10 03:11:50 +0100935 echo "OSM_DOCKER_WORK_DIR=$OSM_DOCKER_WORK_DIR"
garciadeblas7b53d262022-11-04 23:18:48 +0100936 echo "OSM_HELM_WORK_DIR=$OSM_HELM_WORK_DIR"
garciadeblas0cd9b882022-02-10 03:11:50 +0100937 echo "OSM_K8S_WORK_DIR=$OSM_K8S_WORK_DIR"
garciadeblas0bc87522021-10-20 22:16:17 +0200938 echo "OSM_STACK_NAME=$OSM_STACK_NAME"
939 echo "OSM_VCA_HOST=$OSM_VCA_HOST"
940 echo "OSM_VCA_PUBKEY=$OSM_VCA_PUBKEY"
941 echo "OSM_VCA_SECRET=$OSM_VCA_SECRET"
942 echo "OSM_WORK_DIR=$OSM_WORK_DIR"
943 echo "PULL_IMAGES=$PULL_IMAGES"
944 echo "RECONFIGURE=$RECONFIGURE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200945 echo "RELEASE=$RELEASE"
946 echo "REPOSITORY=$REPOSITORY"
947 echo "REPOSITORY_BASE=$REPOSITORY_BASE"
948 echo "REPOSITORY_KEY=$REPOSITORY_KEY"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200949 echo "SHOWOPTS=$SHOWOPTS"
garciadeblas0bc87522021-10-20 22:16:17 +0200950 echo "TEST_INSTALLER=$TEST_INSTALLER"
951 echo "TO_REBUILD=$TO_REBUILD"
952 echo "UNINSTALL=$UNINSTALL"
953 echo "UPDATE=$UPDATE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200954 echo "Install from specific refspec (-b): $COMMIT_ID"
garciadeblas0bc87522021-10-20 22:16:17 +0200955 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200956}
957
garciadeblas453d4582020-12-16 19:03:10 +0100958function parse_docker_registry_url() {
garciadeblas0bc87522021-10-20 22:16:17 +0200959 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100960 DOCKER_REGISTRY_USER=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[1]}')
961 DOCKER_REGISTRY_PASSWORD=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[2]}')
962 DOCKER_REGISTRY_URL=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); print a[2]}')
garciadeblas0bc87522021-10-20 22:16:17 +0200963 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100964}
965
garciadeblasadcf95e2022-01-28 17:15:39 +0100966function ctrl_c() {
967 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
968 echo "** Trapped CTRL-C"
969 FATAL "User stopped the installation"
970 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
971}
972
garciadeblasd8bc5c32018-05-09 17:37:56 +0200973UNINSTALL=""
974DEVELOP=""
garciadeblasd8bc5c32018-05-09 17:37:56 +0200975UPDATE=""
976RECONFIGURE=""
977TEST_INSTALLER=""
978INSTALL_LXD=""
979SHOWOPTS=""
980COMMIT_ID=""
981ASSUME_YES=""
garciadeblas0bc87522021-10-20 22:16:17 +0200982APT_PROXY_URL=""
garciadeblasd8bc5c32018-05-09 17:37:56 +0200983INSTALL_FROM_SOURCE=""
garciadeblas0bc87522021-10-20 22:16:17 +0200984DEBUG_INSTALL=""
garciadeblas00627272021-05-26 16:54:05 +0200985RELEASE="ReleaseTEN"
Mike Marchettib8420852018-09-13 13:45:06 -0400986REPOSITORY="stable"
garciadeblasfa3eb332022-11-15 14:11:56 +0100987INSTALL_K8S_MONITOR=""
garciadeblas7b53d262022-11-04 23:18:48 +0100988INSTALL_NGSA=""
garciadeblasfa3eb332022-11-15 14:11:56 +0100989INSTALL_PLA=""
990INSTALL_VIMEMU=""
garciadeblasd8bc5c32018-05-09 17:37:56 +0200991LXD_REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/lxd"
992LXD_REPOSITORY_PATH=""
993INSTALL_LIGHTWEIGHT="y"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200994INSTALL_TO_OPENSTACK=""
995OPENSTACK_OPENRC_FILE_OR_CLOUD=""
996OPENSTACK_PUBLIC_NET_NAME=""
997OPENSTACK_ATTACH_VOLUME="false"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100998OPENSTACK_SSH_KEY_FILE=""
999OPENSTACK_USERDATA_FILE=""
1000OPENSTACK_VM_NAME="server-osm"
1001OPENSTACK_PYTHON_VENV="$HOME/.virtual-envs/osm"
garciadeblas6c66abf2018-05-16 14:46:19 +02001002INSTALL_ONLY=""
garciadeblas0e596bc2018-05-28 16:04:42 +02001003TO_REBUILD=""
garciadeblasd41f5482018-05-25 10:25:06 +02001004INSTALL_NOLXD=""
garciadeblasa3e26612018-05-30 17:58:55 +02001005INSTALL_NODOCKER=""
Mike Marchettib8420852018-09-13 13:45:06 -04001006INSTALL_NOJUJU=""
garciadeblas0d45bc82018-11-19 14:25:13 +01001007INSTALL_NOHOSTCLIENT=""
garciadeblas0bc87522021-10-20 22:16:17 +02001008INSTALL_CACHELXDIMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001009OSM_DEVOPS=
lavadoe07b1642018-10-25 10:58:34 -05001010OSM_VCA_HOST=
1011OSM_VCA_SECRET=
garciadeblasaa3ddf42019-04-04 19:04:32 +02001012OSM_VCA_PUBKEY=
David Garcia79f4f532020-04-07 12:59:34 +02001013OSM_VCA_CLOUDNAME="localhost"
beierlma4a37f72020-06-26 12:55:01 -04001014OSM_VCA_K8S_CLOUDNAME="k8scloud"
Mike Marchettib8420852018-09-13 13:45:06 -04001015OSM_STACK_NAME=osm
1016NO_HOST_PORTS=""
1017DOCKER_NOBUILD=""
1018REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
garciadeblas870e60a2018-11-21 16:44:21 +01001019REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/debian"
Mike Marchettib8420852018-09-13 13:45:06 -04001020OSM_WORK_DIR="/etc/osm"
garciadeblas7b53d262022-11-04 23:18:48 +01001021OSM_DOCKER_WORK_DIR="${OSM_WORK_DIR}/docker"
vijaynag8339ed22019-07-25 17:10:58 +05301022OSM_K8S_WORK_DIR="${OSM_DOCKER_WORK_DIR}/osm_pods"
garciadeblas7b53d262022-11-04 23:18:48 +01001023OSM_HELM_WORK_DIR="${OSM_WORK_DIR}/helm"
vijaynag8339ed22019-07-25 17:10:58 +05301024OSM_HOST_VOL="/var/lib/osm"
1025OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
Mike Marchetti13d76c82018-09-19 15:00:36 -04001026OSM_DOCKER_TAG=latest
garciadeblas0d45bc82018-11-19 14:25:13 +01001027DOCKER_USER=opensourcemano
1028PULL_IMAGES="y"
Benjamin Diazaa0af712018-10-04 14:02:34 -03001029KAFKA_TAG=2.11-1.0.2
garciadeblas0ab16612022-02-22 14:23:57 +01001030KIWIGRID_K8S_SIDECAR_TAG="1.15.6"
1031PROMETHEUS_TAG=v2.28.1
1032GRAFANA_TAG=8.1.1
lavado6ad812e2019-11-29 10:58:58 -05001033PROMETHEUS_NODE_EXPORTER_TAG=0.18.1
1034PROMETHEUS_CADVISOR_TAG=latest
lavado9a8df7c2018-10-24 09:35:34 -05001035KEYSTONEDB_TAG=10
Benjamin Diazba2cca92018-11-08 21:07:15 -03001036OSM_DATABASE_COMMONKEY=
lavado53eb8f52018-11-16 12:58:23 -05001037ELASTIC_VERSION=6.4.2
lavado4e8662c2018-11-28 11:28:14 -05001038ELASTIC_CURATOR_VERSION=5.5.4
vijaynag8339ed22019-07-25 17:10:58 +05301039POD_NETWORK_CIDR=10.244.0.0/16
1040K8S_MANIFEST_DIR="/etc/kubernetes/manifests"
1041RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
garciadeblas7f1e1042020-11-30 14:07:03 +00001042DOCKER_REGISTRY_URL=
1043DOCKER_PROXY_URL=
1044MODULE_DOCKER_TAG=
garciadeblas4d89c372021-11-25 11:57:18 +01001045OSM_INSTALLATION_TYPE="Default"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001046
garciadeblas0bc87522021-10-20 22:16:17 +02001047while getopts ":a:b:r:n:k:u:R:D:o:O:m:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:-: hy" o; do
garciadeblasd8bc5c32018-05-09 17:37:56 +02001048 case "${o}" in
garciadeblas0bc87522021-10-20 22:16:17 +02001049 a)
1050 APT_PROXY_URL=${OPTARG}
1051 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001052 b)
1053 COMMIT_ID=${OPTARG}
garciadeblas0d45bc82018-11-19 14:25:13 +01001054 PULL_IMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001055 ;;
1056 r)
Mike Marchettib8420852018-09-13 13:45:06 -04001057 REPOSITORY="${OPTARG}"
1058 REPO_ARGS+=(-r "$REPOSITORY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001059 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001060 k)
Mike Marchettib8420852018-09-13 13:45:06 -04001061 REPOSITORY_KEY="${OPTARG}"
1062 REPO_ARGS+=(-k "$REPOSITORY_KEY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001063 ;;
1064 u)
Mike Marchettib8420852018-09-13 13:45:06 -04001065 REPOSITORY_BASE="${OPTARG}"
1066 REPO_ARGS+=(-u "$REPOSITORY_BASE")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001067 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001068 R)
1069 RELEASE="${OPTARG}"
1070 REPO_ARGS+=(-R "$RELEASE")
garciadeblas0d45bc82018-11-19 14:25:13 +01001071 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001072 D)
1073 OSM_DEVOPS="${OPTARG}"
1074 ;;
garciadeblas6c66abf2018-05-16 14:46:19 +02001075 o)
1076 INSTALL_ONLY="y"
garciadeblasb5a630f2020-03-05 18:32:16 +00001077 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblasfa3eb332022-11-15 14:11:56 +01001078 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
garciadeblas6c66abf2018-05-16 14:46:19 +02001079 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001080 O)
1081 INSTALL_TO_OPENSTACK="y"
1082 if [ -n "${OPTARG}" ]; then
1083 OPENSTACK_OPENRC_FILE_OR_CLOUD="${OPTARG}"
1084 else
1085 echo -e "Invalid argument for -O : ' $OPTARG'\n" >&2
1086 usage && exit 1
1087 fi
1088 ;;
Antonio Marsico75a38c72020-12-21 17:29:42 +01001089 f)
1090 OPENSTACK_SSH_KEY_FILE="${OPTARG}"
1091 ;;
1092 F)
1093 OPENSTACK_USERDATA_FILE="${OPTARG}"
1094 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001095 N)
1096 OPENSTACK_PUBLIC_NET_NAME="${OPTARG}"
1097 ;;
garciadeblas0e596bc2018-05-28 16:04:42 +02001098 m)
garciadeblas7f1e1042020-11-30 14:07:03 +00001099 [ "${OPTARG}" == "NG-UI" ] && TO_REBUILD="$TO_REBUILD NG-UI" && continue
govindappa79e51b92019-05-22 12:15:21 +05301100 [ "${OPTARG}" == "NBI" ] && TO_REBUILD="$TO_REBUILD NBI" && continue
1101 [ "${OPTARG}" == "LCM" ] && TO_REBUILD="$TO_REBUILD LCM" && continue
1102 [ "${OPTARG}" == "RO" ] && TO_REBUILD="$TO_REBUILD RO" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001103 [ "${OPTARG}" == "MON" ] && TO_REBUILD="$TO_REBUILD MON" && continue
govindappa79e51b92019-05-22 12:15:21 +05301104 [ "${OPTARG}" == "POL" ] && TO_REBUILD="$TO_REBUILD POL" && continue
garciadeblas7f1e1042020-11-30 14:07:03 +00001105 [ "${OPTARG}" == "PLA" ] && TO_REBUILD="$TO_REBUILD PLA" && continue
1106 [ "${OPTARG}" == "osmclient" ] && TO_REBUILD="$TO_REBUILD osmclient" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001107 [ "${OPTARG}" == "KAFKA" ] && TO_REBUILD="$TO_REBUILD KAFKA" && continue
1108 [ "${OPTARG}" == "MONGO" ] && TO_REBUILD="$TO_REBUILD MONGO" && continue
govindappa79e51b92019-05-22 12:15:21 +05301109 [ "${OPTARG}" == "PROMETHEUS" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS" && continue
garciadeblasfc5bb142019-12-10 10:49:12 +01001110 [ "${OPTARG}" == "PROMETHEUS-CADVISOR" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS-CADVISOR" && continue
govindappa79e51b92019-05-22 12:15:21 +05301111 [ "${OPTARG}" == "KEYSTONE-DB" ] && TO_REBUILD="$TO_REBUILD KEYSTONE-DB" && continue
lavado6ad812e2019-11-29 10:58:58 -05001112 [ "${OPTARG}" == "GRAFANA" ] && TO_REBUILD="$TO_REBUILD GRAFANA" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001113 [ "${OPTARG}" == "NONE" ] && TO_REBUILD="$TO_REBUILD NONE" && continue
1114 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001115 H)
1116 OSM_VCA_HOST="${OPTARG}"
1117 ;;
1118 S)
1119 OSM_VCA_SECRET="${OPTARG}"
1120 ;;
1121 s)
garciadeblas0bc87522021-10-20 22:16:17 +02001122 OSM_STACK_NAME="${OPTARG}" && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
garciadeblas25e87d22020-01-31 14:27:29 +01001123 ;;
1124 t)
1125 OSM_DOCKER_TAG="${OPTARG}"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001126 REPO_ARGS+=(-t "$OSM_DOCKER_TAG")
garciadeblas25e87d22020-01-31 14:27:29 +01001127 ;;
1128 U)
1129 DOCKER_USER="${OPTARG}"
1130 ;;
1131 P)
1132 OSM_VCA_PUBKEY=$(cat ${OPTARG})
1133 ;;
1134 A)
1135 OSM_VCA_APIPROXY="${OPTARG}"
1136 ;;
David Garcia79f4f532020-04-07 12:59:34 +02001137 l)
1138 LXD_CLOUD_FILE="${OPTARG}"
1139 ;;
1140 L)
1141 LXD_CRED_FILE="${OPTARG}"
1142 ;;
David Garcia404ae122020-04-28 11:47:55 +02001143 K)
1144 CONTROLLER_NAME="${OPTARG}"
1145 ;;
garciadeblas7f1e1042020-11-30 14:07:03 +00001146 d)
1147 DOCKER_REGISTRY_URL="${OPTARG}"
1148 ;;
1149 p)
1150 DOCKER_PROXY_URL="${OPTARG}"
1151 ;;
1152 T)
1153 MODULE_DOCKER_TAG="${OPTARG}"
1154 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001155 -)
1156 [ "${OPTARG}" == "help" ] && usage && exit 0
garciadeblas0d45bc82018-11-19 14:25:13 +01001157 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && PULL_IMAGES="" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001158 [ "${OPTARG}" == "debug" ] && DEBUG_INSTALL="--debug" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001159 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
1160 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001161 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
1162 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
1163 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
1164 [ "${OPTARG}" == "lxdinstall" ] && INSTALL_LXD="y" && continue
garciadeblasd41f5482018-05-25 10:25:06 +02001165 [ "${OPTARG}" == "nolxd" ] && INSTALL_NOLXD="y" && continue
garciadeblasa3e26612018-05-30 17:58:55 +02001166 [ "${OPTARG}" == "nodocker" ] && INSTALL_NODOCKER="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001167 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001168 [ "${OPTARG}" == "nohostports" ] && NO_HOST_PORTS="y" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001169 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="--nojuju" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001170 [ "${OPTARG}" == "nodockerbuild" ] && DOCKER_NOBUILD="y" && continue
1171 [ "${OPTARG}" == "nohostclient" ] && INSTALL_NOHOSTCLIENT="y" && continue
garciadeblas0d45bc82018-11-19 14:25:13 +01001172 [ "${OPTARG}" == "pullimages" ] && continue
garciadeblasb5a630f2020-03-05 18:32:16 +00001173 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblas4d89c372021-11-25 11:57:18 +01001174 [ "${OPTARG}" == "charmed" ] && CHARMED="y" && OSM_INSTALLATION_TYPE="Charmed" && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001175 [ "${OPTARG}" == "bundle" ] && continue
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +02001176 [ "${OPTARG}" == "k8s" ] && continue
1177 [ "${OPTARG}" == "lxd" ] && continue
1178 [ "${OPTARG}" == "lxd-cred" ] && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001179 [ "${OPTARG}" == "microstack" ] && continue
David Garcia4bd2bf02021-05-05 19:01:43 +02001180 [ "${OPTARG}" == "overlay" ] && continue
David Garcia1bc71022021-05-03 18:27:18 +02001181 [ "${OPTARG}" == "only-vca" ] && continue
aticig5d19ac22022-05-06 13:46:22 +03001182 [ "${OPTARG}" == "small-profile" ] && continue
Dominik Fleischmannc63bed62020-09-25 12:17:54 +02001183 [ "${OPTARG}" == "vca" ] && continue
Dominik Fleischmannc57296f2020-06-09 11:45:08 +02001184 [ "${OPTARG}" == "ha" ] && continue
David Garcia69388c22020-05-07 12:14:19 +02001185 [ "${OPTARG}" == "tag" ] && continue
beierlmf2782c52020-11-05 17:04:05 -05001186 [ "${OPTARG}" == "registry" ] && continue
magnussonl1bbe9452020-02-25 13:43:17 +01001187 [ "${OPTARG}" == "pla" ] && INSTALL_PLA="y" && continue
garciadeblas7b53d262022-11-04 23:18:48 +01001188 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001189 [ "${OPTARG}" == "volume" ] && OPENSTACK_ATTACH_VOLUME="true" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001190 [ "${OPTARG}" == "nocachelxdimages" ] && continue
1191 [ "${OPTARG}" == "cachelxdimages" ] && INSTALL_CACHELXDIMAGES="--cachelxdimages" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001192 echo -e "Invalid option: '--$OPTARG'\n" >&2
1193 usage && exit 1
1194 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001195 :)
1196 echo "Option -$OPTARG requires an argument" >&2
1197 usage && exit 1
1198 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001199 \?)
1200 echo -e "Invalid option: '-$OPTARG'\n" >&2
1201 usage && exit 1
1202 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001203 h)
1204 usage && exit 0
1205 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001206 y)
1207 ASSUME_YES="y"
1208 ;;
1209 *)
1210 usage && exit 1
1211 ;;
1212 esac
1213done
1214
garciadeblas0bc87522021-10-20 22:16:17 +02001215source $OSM_DEVOPS/common/all_funcs
garciadeblas6c66abf2018-05-16 14:46:19 +02001216
garciadeblas0bc87522021-10-20 22:16:17 +02001217[ -z "${DEBUG_INSTALL}" ] || DEBUG Debug is on
1218[ -n "$SHOWOPTS" ] && dump_vars && exit 0
1219
1220# Uninstall if "--uninstall"
1221if [ -n "$UNINSTALL" ]; then
1222 if [ -n "$CHARMED" ]; then
garciadeblas4d89c372021-11-25 11:57:18 +01001223 ${OSM_DEVOPS}/installers/charmed_uninstall.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $OSM_DEVOPS -t $DOCKER_TAG "$@" || \
1224 FATAL_TRACK charmed_uninstall "charmed_uninstall.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001225 else
garciadeblas4d89c372021-11-25 11:57:18 +01001226 ${OSM_DEVOPS}/installers/uninstall_osm.sh "$@" || \
1227 FATAL_TRACK community_uninstall "uninstall_osm.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001228 fi
1229 echo -e "\nDONE"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001230 exit 0
1231fi
1232
garciadeblas0bc87522021-10-20 22:16:17 +02001233# Charmed installation
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001234if [ -n "$CHARMED" ]; then
Mark Beierlbc0d6072022-12-12 09:00:59 -05001235 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
beierlmce7b4602022-04-13 08:19:40 -04001236 export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
1237 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
1238 ${OSM_DEVOPS}/installers/charmed_install.sh --tag $OSM_DOCKER_TAG "$@" || \
garciadeblas4d89c372021-11-25 11:57:18 +01001239 FATAL_TRACK charmed_install "charmed_install.sh failed"
garciadeblas89c5f552022-11-24 20:16:57 +01001240 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
beierlmce7b4602022-04-13 08:19:40 -04001241 track end installation_type $OSM_INSTALLATION_TYPE
garciadeblas0bc87522021-10-20 22:16:17 +02001242 echo -e "\nDONE"
1243 exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001244fi
1245
garciadeblas0bc87522021-10-20 22:16:17 +02001246# Installation to Openstack
1247if [ -n "$INSTALL_TO_OPENSTACK" ]; then
1248 install_to_openstack $OPENSTACK_OPENRC_FILE_OR_CLOUD $OPENSTACK_PUBLIC_NET_NAME $OPENSTACK_ATTACH_VOLUME
1249 echo -e "\nDONE"
1250 exit 0
1251fi
1252
1253# Community_installer
garciadeblasfa3eb332022-11-15 14:11:56 +01001254
garciadeblas0bc87522021-10-20 22:16:17 +02001255[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" != " NONE" ] && echo $TO_REBUILD | grep -q NONE && FATAL "Incompatible option: -m NONE cannot be used with other -m options"
1256[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" == " PLA" ] && [ -z "$INSTALL_PLA" ] && FATAL "Incompatible option: -m PLA cannot be used without --pla option"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001257# if develop, we force master
1258[ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
garciadeblas0bc87522021-10-20 22:16:17 +02001259OSM_K8S_WORK_DIR="$OSM_DOCKER_WORK_DIR/osm_pods" && OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
garciadeblasb5a630f2020-03-05 18:32:16 +00001260[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_K8S_MONITOR" ] && install_k8s_monitoring
garciadeblasfa3eb332022-11-15 14:11:56 +01001261[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_NGSA" ] && install_osm_ngsa_service
garciadeblas6c66abf2018-05-16 14:46:19 +02001262[ -n "$INSTALL_ONLY" ] && echo -e "\nDONE" && exit 0
garciadeblasd8bc5c32018-05-09 17:37:56 +02001263
1264#Installation starts here
garciadeblas89c5f552022-11-24 20:16:57 +01001265wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README.txt &> /dev/null
garciadeblas4d89c372021-11-25 11:57:18 +01001266export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
garciadeblas0bc87522021-10-20 22:16:17 +02001267install_osm
garciadeblasd8bc5c32018-05-09 17:37:56 +02001268echo -e "\nDONE"
garciadeblas4d89c372021-11-25 11:57:18 +01001269exit 0